Index: /trunk/VUT/GtpVisibilityPreprocessor/scripts/Preprocessor.vcproj
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/scripts/Preprocessor.vcproj	(revision 577)
+++ /trunk/VUT/GtpVisibilityPreprocessor/scripts/Preprocessor.vcproj	(revision 580)
@@ -77,5 +77,6 @@
 				Name="VCLinkerTool"
 				AdditionalDependencies="xerces-c_2.lib zdll.lib zziplib.lib devil.lib qtmain.lib QtOpenGL4.lib QtCore4.lib QtGui4.lib Qt3Supportd4.lib QAxContainer.lib glut32.lib OpenGL32.Lib glu32.lib cg.lib cgGL.lib"
-				AdditionalLibraryDirectories="..\support\xercesc\lib\;..\support\zlib\lib\;..\support\devil\lib;&quot;$(QTDIR)\lib&quot;;..\include;..\src\GL;&quot;$(CG_LIB_PATH)&quot;"/>
+				AdditionalLibraryDirectories="..\support\xercesc\lib\;..\support\zlib\lib\;..\support\devil\lib;&quot;$(QTDIR)\lib&quot;;..\include;..\src\GL;&quot;$(CG_LIB_PATH)&quot;"
+				LargeAddressAware="2"/>
 			<Tool
 				Name="VCMIDLTool"/>
Index: /trunk/VUT/GtpVisibilityPreprocessor/scripts/default.env
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/scripts/default.env	(revision 579)
+++ /trunk/VUT/GtpVisibilityPreprocessor/scripts/default.env	(revision 580)
@@ -176,6 +176,6 @@
 	# samples used for view cell construction
 	Construction {
-		samples 1500000
-		samplesPerPass 100000
+		samples 1200000
+		samplesPerPass 300000
 	}
 
@@ -195,5 +195,4 @@
 	maxPvsRatio 1.0
 		
-	delayedConstruction false
 	pruneEmptyViewCells false
 	processOnlyValidViewCells false
@@ -202,4 +201,10 @@
 		# how much samples are used for post processing
 		samples 300000
+		renderCostWeight 0.5
+		maxCostRatio 0.1
+		minViewCells 110
+		avgCostMaxDeviation 0.8
+		maxMergesPerPass 500 
+		useRaysForMerge false
 	}
 
@@ -213,4 +218,5 @@
 		exportRays false
 		exportGeometry true
+		exportMergedViewCells false
 	}
 	
@@ -274,4 +280,5 @@
 		epsilon 0.005
 		randomize false
+		renderCostWeight 0.5
 	}
 
@@ -331,12 +338,4 @@
 		# x3d visualization of the split planes
 		exportSplits true
-		exportMergedViewCells false
-	}
-	
-	PostProcess {
-		maxCostRatio 0.1
-		minViewCells 110
-		useRaysForMerge false
-		exportMergeStats false
 	}
 }
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.h	(revision 579)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.h	(revision 580)
@@ -21,5 +21,5 @@
 class ViewCellsStatistics;
 class ViewCellsManager;
-class BspMergeCandidate;
+class MergeCandidate;
 class Beam;
 
@@ -252,15 +252,4 @@
 	int TreeDistance(BspNode *n1, BspNode *n2) const;
 
-	/** Merges view cells according to some cost heuristics.
-	*/
-	int MergeViewCells(const VssRayContainer &rays, const ObjectContainer &objects);
-	
-	/** Refines view cells using shuffling, i.e., border leaves 
-		of two view cells are exchanged if the resulting view cells
-		are tested to be "better" than the old ones.
-		@returns number of refined view cells
-	*/
-	int RefineViewCells(const VssRayContainer &rays, const ObjectContainer &objects);
-
 	/** Collapses the tree with respect to the view cell partition.
 		@returns number of collapsed nodes
@@ -272,12 +261,4 @@
 	ViewCell *GetViewCell(const Vector3 &point);
 
-	/** Constructs bsp rays for post processing and visualization.
-	*/
-	void ConstructBspRays(vector<BspRay *> &bspRays,
-						  const VssRayContainer &rays);
-	
-	/** Merge view cells of leaves l1 and l2.
-	*/
-	bool MergeViewCells(BspLeaf *l1, BspLeaf *l2); //const;
 
 	/** Returns true if this view point is in a valid view space,
@@ -369,9 +350,4 @@
 	BspNode *CollapseTree(BspNode *node, int &collapsed);
 
-	/** Shuffles the leaves, i.e., tests if exchanging
-		the leaves helps in improving the view cells.
-	*/
-	bool ShuffleLeaves(BspLeaf *leaf1, BspLeaf *leaf2) const;
-
 	/** Helper function revalidating the view cell leaf list after merge.
 	*/
@@ -573,14 +549,8 @@
 
 
-	/** Collects candidates for the merge in the merge queue.
-		@param leaves the leaves to be merged
-		@returns number of leaves in queue
-	*/
-	int CollectMergeCandidates(const vector<BspLeaf *> leaves);
-	/** Collects candidates for the merge in the merge queue.
-		@returns number of leaves in queue
-	*/
-	int CollectMergeCandidates(const VssRayContainer &rays);
-
+
+
+
+	
 	/** Take 3 ray endpoints, where two are minimum and one a maximum
 		point or the other way round.
@@ -599,11 +569,16 @@
 	Plane3 ChooseCandidatePlane3(const RayInfoContainer &rays) const;
   
-	/** Shuffles, i.e. takes border leaf from view cell 1 and adds it 
-		to view cell 2.
-	*/
-	void ShuffleLeaf(BspLeaf *leaf, 
-					 BspViewCell *vc1, 
-					 BspViewCell *vc2) const;
-
+	/** Collects candidates for merging.
+		@param leaves the leaves to be merged
+		@returns number of leaves in queue
+	*/
+	int CollectMergeCandidates(const vector<BspLeaf *> leaves, vector<MergeCandidate> &candidates);
+
+	/** Collects candidates for the merge in the merge queue.
+		@returns number of leaves in queue
+	*/
+	int CollectMergeCandidates(const VssRayContainer &rays, vector<MergeCandidate> &candidates);
+	
+	
 	
 	/** Propagates valid flag up the tree.
@@ -620,11 +595,5 @@
 	float GetMemUsage() const;
 
-	/** Calculates cost for merge of view cell 1 and 2.
-	*/
-	float GetShuffledVcCost(BspLeaf *leaf, BspViewCell *vc1, BspViewCell *vc2) const;
-
-	void ExportMergedViewCells(ViewCellContainer &viewCells, 
-							   const ObjectContainer &objects,
-							   const int nViewCells);
+
 
 	/// Pointer to the root of the tree
@@ -658,5 +627,5 @@
 	float mTermMinAccRayLength;
 
-	ofstream mStats;
+	
 
 	//-- termination criteria for axis aligned split
@@ -701,8 +670,5 @@
 	/// maximal number of view cells
 	int mMaxViewCells;
-	/// minimal number of view cells
-	int mMergeMinViewCells;
-	/// maximal cost ratio for the merge
-	float mMergeMaxCostRatio;
+	
 
 	// if rays should be stored in leaves
@@ -716,16 +682,8 @@
 	vector<SortableEntry> *mSplitCandidates;
 
-
-	typedef priority_queue<BspMergeCandidate> MergeQueue;
-
-	MergeQueue mMergeQueue;
-
-	/// if rays should be used to collect merge candidates
-	bool mUseRaysForMerge;
-	
+	
+	float mRenderCostWeight;
 	/// View cell corresponding to the space outside the valid view space
 	BspViewCell *mOutOfBoundsCell;
-
-	int mCurrentViewCellsId;
 
 	/// maximal tree memory
@@ -733,13 +691,8 @@
 	/// the tree is out of memory
 	bool mOutOfMemory;
-	/// if merge visualization should be shown
-	bool mExportMergedViewCells;
-	/// if merge statistics should be exported
-	bool mExportMergeStats;
-
+	
+	
 private:
-	
-	ViewCellContainer mOldViewCells;
-	ViewCellContainer mNewViewCells;
+
 
 	static const float sLeastRaySplitsTable[5];
@@ -758,150 +711,6 @@
 };
 
-/**
-	Candidate for leaf merging based on priority.
-*/
-class BspMergeCandidate
-{  
-	friend class VspBspTree;
-
-public:
-
-	BspMergeCandidate(BspLeaf *l1, BspLeaf *l2);
-
-	/** If this merge pair is still valid.
-	*/
-	bool Valid() const;
-
-	/** Sets this merge candidate to be valid.
-	*/
-	void SetValid();
-
-	friend bool operator<(const BspMergeCandidate &leafa, const BspMergeCandidate &leafb)
-	{
-		return leafb.GetMergeCost() < leafa.GetMergeCost();
-	}
-
-	void SetLeaf1(BspLeaf *l);
-	void SetLeaf2(BspLeaf *l);
-
-	BspLeaf *GetLeaf1() const;
-	BspLeaf *GetLeaf2() const;
-
-	/** Merge cost of this candidate pair.
-	*/
-	float GetMergeCost() const;
-
-	/** Render cost of this candidate.
-	*/
-	float GetRenderCost() const;
-
-	/** returns increase in variance of this view cell.
-	*/
-	float GetVarianceIncr() const;
-
-	/** Returns cost of leaf 1.
-	*/
-	float GetLeaf1Cost() const;
-	
-	/** Returns cost of leaf 2.
-	*/
-	float GetLeaf2Cost() const;
-
-	/** Variance of leaf1
-	*/
-	float GetLeaf1Variance() const;
-
-	/** Variance of leaf2
-	*/
-	float GetLeaf2Variance() const;
-
-	/// overall cost used to normalize cost ratio
-	static float sOverallCost;
-	static float sExpectedCost;
-	static float sVariance;
-
-	static int sNumViewCells;
-
-	// weights between variance and render cost increase (must between zero and one)
-	static float sRenderCostWeight;
-
-	/// if area or volume should be used for the merge heuristics
-	static bool sUseArea;
-
-	/// pointer to view cells manager
-	static ViewCellsManager *sViewCellsManager;
-
-protected:
-
-	
-	/** Evaluates the merge costs of the leaves.
-	*/
-	void EvalMergeCost();
-
-	/** render cost of a view cell.
-	*/
-	float GetRenderCost(ViewCell *vc) const;
-	
-	int mLeaf1Id;
-	int mLeaf2Id;
-
-	/// render cost increase by this merge
-	float mRenderCost;
-	/// increase / decrease of variance
-	float mVarianceIncr;
-
-	BspLeaf *mLeaf1;
-	BspLeaf *mLeaf2;
-};
-
-
-class MergeStatistics: public StatisticsBase
-{
-public:
-	
-	int merged;
-	int siblings;
-	int candidates;
-	int nodes;
-
-	int accTreeDist;
-	int maxTreeDist;
-	
-	Real collectTime;
-	Real mergeTime;
-
-	Real overallCost;
-
-	// Constructor
-	MergeStatistics() 
-	{
-		Reset();
-	}
-	
-	double AvgTreeDist() const {return (double)accTreeDist / (double)merged;}; 
-
-	void Reset() 
-	{
-		nodes = 0;
-		merged = 0;
-		siblings = 0;
-		candidates = 0;
-	
-		accTreeDist = 0;
-		maxTreeDist = 0;
-
-		collectTime = 0;
-		mergeTime = 0;
-		overallCost = 0;
-	}
-
-	void Print(ostream &app) const;
-
-	friend ostream &operator<<(ostream &s, const MergeStatistics &stat) 
-	{
-		stat.Print(s);
-		return s;
-	} 
-};
+
+
 
 #endif
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/VspKdTree.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/VspKdTree.cpp	(revision 556)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/VspKdTree.cpp	(revision 580)
@@ -30,6 +30,6 @@
 // Static variables
 int VspKdLeaf::sMailId = 0;
-int MergeCandidate::sMaxPvsSize = 150;
-float MergeCandidate::sOverallCost = Limits::Small;
+int VspKdMergeCandidate::sMaxPvsSize = 150;
+float VspKdMergeCandidate::sOverallCost = Limits::Small;
 #define USE_FIXEDPOINT_T 0
 
@@ -430,5 +430,5 @@
 	environment->GetFloatValue("VspKdTree.PostProcess.maxCostRatio", mMergeMaxCostRatio);
 	environment->GetIntValue("VspKdTree.PostProcess.maxPvsSize",
-							 MergeCandidate::sMaxPvsSize);
+							 VspKdMergeCandidate::sMaxPvsSize);
 
 	environment->GetBoolValue("VspKdTree.splitUseOnlyDrivingAxis", mOnlyDrivingAxis);
@@ -2173,5 +2173,5 @@
 	vc->SetArea(GetBBox(leaf).SurfaceArea());
 
-	vc->mLeaves.push_back(leaf);
+	vc->mLeaf = leaf;
 
 	for (it = leaf->GetRays().begin(); it != it_end; ++ it)
@@ -2200,5 +2200,6 @@
 	// if merge was unsuccessful
 	if (!vc) return false;
-
+// TODO
+#if VC_HISTORY
 	// set new size of view cell
 	vc->SetVolume(fVc->GetVolume() + bVc->GetVolume());
@@ -2223,5 +2224,5 @@
 		vc->mLeaves.push_back(*it);
 	}
-
+#endif
 	vc->Mail();
 
@@ -2235,5 +2236,5 @@
 void VspKdTree::CollectMergeCandidates()
 {
-	MergeCandidate::sOverallCost = 0;
+	VspKdMergeCandidate::sOverallCost = 0;
 	vector<VspKdLeaf *> leaves;
 
@@ -2256,5 +2257,5 @@
 		// no leaf is part of two merge candidates
 		leaf->Mail();
-		MergeCandidate::sOverallCost += 
+		VspKdMergeCandidate::sOverallCost += 
 			vc->GetVolume() * vc->GetPvs().GetSize();
 		vector<VspKdLeaf *> neighbors;
@@ -2266,5 +2267,5 @@
 		for (nit = neighbors.begin(); nit != nit_end; ++ nit)
 		{
-			mMergeQueue.push(MergeCandidate(leaf, *nit));
+			mMergeQueue.push(VspKdMergeCandidate(leaf, *nit));
 		}
 	}
@@ -2273,5 +2274,5 @@
 void VspKdTree::CollectMergeCandidates(const vector<VspKdRay *> &rays)
 {
-	MergeCandidate::sOverallCost = 0;
+	VspKdMergeCandidate::sOverallCost = 0;
 
 	vector<VspKdIntersection>::const_iterator iit;
@@ -2299,9 +2300,9 @@
 			leaf->Mail
 			// TODO: how to sort out doubles?
-			MergeCandidate mc = MergeCandidate(leaf, previousLeaf);
+			VspKdMergeCandidate mc = VspKdMergeCandidate(leaf, previousLeaf);
 			mMergeQueue.push(mc);
 
-			MergeCandidate::sOverallCost += mc.GetLeaf1Cost();
-			MergeCandidate::sOverallCost += mc.GetLeaf2Cost();
+			VspKdMergeCandidate::sOverallCost += mc.GetLeaf1Cost();
+			VspKdMergeCandidate::sOverallCost += mc.GetLeaf2Cost();
 
 			previousLeaf = leaf;
@@ -2321,9 +2322,9 @@
 	while (!mMergeQueue.empty() && (vcSize > mMergeMinViewCells) &&
 		   (mMergeQueue.top().GetMergeCost() < 
-		    mMergeMaxCostRatio * MergeCandidate::sOverallCost))
+		    mMergeMaxCostRatio * VspKdMergeCandidate::sOverallCost))
 	{
 		//Debug << "mergecost: " << mergeQueue.top().GetMergeCost() / 
-		//MergeCandidate::sOverallCost << " " << mMergeMaxCostRatio << endl;
-		MergeCandidate mc = mMergeQueue.top();
+		//VspKdMergeCandidate::sOverallCost << " " << mMergeMaxCostRatio << endl;
+		VspKdMergeCandidate mc = mMergeQueue.top();
 		mMergeQueue.pop();
 
@@ -2340,5 +2341,5 @@
 			-- vcSize;
 			// increase absolute merge cost
-			MergeCandidate::sOverallCost += mc.GetMergeCost();
+			VspKdMergeCandidate::sOverallCost += mc.GetMergeCost();
 		}
 		// merge candidate not valid, because one of the leaves was already
@@ -2378,5 +2379,5 @@
 
 			VspKdViewCell *viewCell = leaf->GetViewCell();
-
+#if VC_HISTORY
 			if (!viewCell->Mailed())
 			{
@@ -2386,4 +2387,5 @@
 
 			viewCell->mLeaves.push_back(leaf);
+#endif
 		}
 		else
@@ -2468,5 +2470,5 @@
 	while (!mMergeQueue.empty())
 	{
-		MergeCandidate mc = mMergeQueue.top();
+		VspKdMergeCandidate mc = mMergeQueue.top();
 		mMergeQueue.pop();
 
@@ -2501,5 +2503,5 @@
 
 
-float GetShuffledVcCost(VspKdLeaf *leaf, VspKdViewCell *vc1, VspKdViewCell *vc2)
+float EvalShuffleCost(VspKdLeaf *leaf, VspKdViewCell *vc1, VspKdViewCell *vc2)
 {
 	const int pvs1 = SubtractedPvsSize(vc1->GetPvs(), *leaf->mPvs);
@@ -2521,4 +2523,6 @@
 {
 	// compute new pvs and area
+	//	TODO
+#if VC_HISTORY
 	vc1->GetPvs().SubtractPvs(*leaf->mPvs);
 	vc2->GetPvs().AddPvs(*leaf->mPvs);
@@ -2537,4 +2541,5 @@
 
 	leaf->SetViewCell(vc2);  // finally change view cell
+#endif
 }
 
@@ -2554,10 +2559,11 @@
 
 	// the view cell should not be empty after the shuffle
-	if (vc1->mLeaves.size() > 1)
-		shuffledCost1 = GetShuffledVcCost(leaf1, vc1, vc2);
+//todo
+	/*	if (vc1->mLeaves.size() > 1)
+		shuffledCost1 = EvalShuffleCost(leaf1, vc1, vc2);
 	if (vc2->mLeaves.size() > 1)
-		shuffledCost2 = GetShuffledVcCost(leaf2, vc2, vc1);
-
-	// shuffling unsuccessful
+		shuffledCost2 = EvalShuffleCost(leaf2, vc2, vc1);
+
+*/	// shuffling unsuccessful
 	if ((oldCost <= shuffledCost1) && (oldCost <= shuffledCost2))
 		return false;
@@ -2581,9 +2587,9 @@
 
 /*********************************************************************/
-/*                MergeCandidate implementation                      */
+/*                VspKdMergeCandidate implementation                      */
 /*********************************************************************/
 
 
-MergeCandidate::MergeCandidate(VspKdLeaf *l1, VspKdLeaf *l2):
+VspKdMergeCandidate::VspKdMergeCandidate(VspKdLeaf *l1, VspKdLeaf *l2):
 mMergeCost(0),
 mLeaf1(l1),
@@ -2595,5 +2601,5 @@
 }
 
-float MergeCandidate::GetLeaf1Cost() const
+float VspKdMergeCandidate::GetLeaf1Cost() const
 {
 	VspKdViewCell *vc = mLeaf1->GetViewCell();
@@ -2601,5 +2607,5 @@
 }
 
-float MergeCandidate::GetLeaf2Cost() const
+float VspKdMergeCandidate::GetLeaf2Cost() const
 {
 	VspKdViewCell *vc = mLeaf2->GetViewCell();
@@ -2607,5 +2613,5 @@
 }
 
-void MergeCandidate::EvalMergeCost()
+void VspKdMergeCandidate::EvalMergeCost()
 {
 	//-- compute pvs difference
@@ -2630,10 +2636,10 @@
 }
 
-void MergeCandidate::SetLeaf1(VspKdLeaf *l)
+void VspKdMergeCandidate::SetLeaf1(VspKdLeaf *l)
 {
 	mLeaf1 = l;
 }
 
-void MergeCandidate::SetLeaf2(VspKdLeaf *l)
+void VspKdMergeCandidate::SetLeaf2(VspKdLeaf *l)
 {
 	mLeaf2 = l;
@@ -2641,5 +2647,5 @@
 
 
-VspKdLeaf *MergeCandidate::GetLeaf1()
+VspKdLeaf *VspKdMergeCandidate::GetLeaf1()
 {
 	return mLeaf1;
@@ -2647,5 +2653,5 @@
 
 
-VspKdLeaf *MergeCandidate::GetLeaf2()
+VspKdLeaf *VspKdMergeCandidate::GetLeaf2()
 {
 	return mLeaf2;
@@ -2653,5 +2659,5 @@
 
 
-bool MergeCandidate::Valid() const
+bool VspKdMergeCandidate::Valid() const
 {
 	return
@@ -2661,5 +2667,5 @@
 
 
-float MergeCandidate::GetMergeCost() const
+float VspKdMergeCandidate::GetMergeCost() const
 {
 	return mMergeCost;
@@ -2667,5 +2673,5 @@
 
 
-void MergeCandidate::SetValid()
+void VspKdMergeCandidate::SetValid()
 {
 	mLeaf1Id = mLeaf1->GetViewCell()->mMailbox;
